"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HttpFilter = void 0;
const common_1 = require("@nestjs/common");
const rxjs_1 = require("rxjs");
const operators_1 = require("rxjs/operators");
let HttpFilter = class HttpFilter {
    catch(error, host) {
        const response = host
            .switchToHttp()
            .getResponse();
        const body = this.parseError(error);
        response.statusCode = body.statusCode;
        return (0, rxjs_1.of)(response.json(body)).pipe((0, operators_1.map)(() => undefined));
    }
    parseError(error) {
        let statusCode = 500;
        let message = error.message;
        let errorType = 'Internal Error';
        if (error.response) {
            statusCode = error.response.statusCode || statusCode;
            message = error.response.message || message;
            errorType = error.response.error;
        }
        return { statusCode, message, error: errorType };
    }
};
HttpFilter = __decorate([
    (0, common_1.Catch)()
], HttpFilter);
exports.HttpFilter = HttpFilter;
