"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SendMessageResponse = exports.SendMessageReply = exports.SendBytesMessageBody = exports.SendDataMessageBody = exports.SendDataBody = exports.GetMessageListQuery = exports.ErrorModel = exports.MessageModel = void 0;
const swagger_1 = require("@nestjs/swagger");
const class_transformer_1 = require("class-transformer");
const class_validator_1 = require("class-validator");
const http_transformer_1 = require("../../http/nest/http.transformer");
const common_1 = require("../../../core/common");
const socket_1 = require("../../../core/socket");
class MessageModel {
}
__decorate([
    (0, swagger_1.ApiProperty)({ type: 'number' }),
    __metadata("design:type", Number)
], MessageModel.prototype, "id", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ enum: socket_1.SocketEventType }),
    __metadata("design:type", String)
], MessageModel.prototype, "type", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ type: 'string', example: new Date() }),
    __metadata("design:type", Date)
], MessageModel.prototype, "date", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ type: 'object' }),
    __metadata("design:type", Object)
], MessageModel.prototype, "message", void 0);
exports.MessageModel = MessageModel;
class ErrorModel {
}
__decorate([
    (0, swagger_1.ApiProperty)({ type: 'number' }),
    __metadata("design:type", Number)
], ErrorModel.prototype, "statusCode", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ type: 'object' }),
    __metadata("design:type", Object)
], ErrorModel.prototype, "message", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ type: 'string' }),
    __metadata("design:type", String)
], ErrorModel.prototype, "error", void 0);
exports.ErrorModel = ErrorModel;
class GetMessageListQuery {
}
__decorate([
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.IsIn)(common_1.EnumUtil.values(socket_1.SocketEventType), { each: true }),
    (0, class_transformer_1.Transform)(http_transformer_1.toArray),
    __metadata("design:type", Array)
], GetMessageListQuery.prototype, "type", void 0);
exports.GetMessageListQuery = GetMessageListQuery;
class SendDataBody {
}
__decorate([
    (0, swagger_1.ApiProperty)({ type: 'object', description: 'Any data' }),
    (0, class_validator_1.ValidateIf)(object => object.bytes === undefined),
    __metadata("design:type", Object)
], SendDataBody.prototype, "data", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ type: 'number', isArray: true, description: 'UInt8 Array' }),
    (0, class_validator_1.ValidateIf)(object => object.data === undefined),
    (0, class_validator_1.IsArray)(),
    (0, class_validator_1.Min)(0, { each: true }),
    (0, class_validator_1.Max)(255, { each: true }),
    __metadata("design:type", Array)
], SendDataBody.prototype, "bytes", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ type: 'string', required: false, description: 'Only for SocketIO', default: '*' }),
    (0, class_validator_1.IsOptional)(),
    (0, class_validator_1.IsString)(),
    __metadata("design:type", String)
], SendDataBody.prototype, "event", void 0);
exports.SendDataBody = SendDataBody;
class SendDataMessageBody {
}
__decorate([
    (0, swagger_1.ApiProperty)({ type: 'object', description: 'Any data' }),
    __metadata("design:type", Object)
], SendDataMessageBody.prototype, "data", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ type: 'string', required: false, description: 'Only for SocketIO', default: '*' }),
    __metadata("design:type", String)
], SendDataMessageBody.prototype, "event", void 0);
exports.SendDataMessageBody = SendDataMessageBody;
class SendBytesMessageBody {
}
__decorate([
    (0, swagger_1.ApiProperty)({ type: 'number', isArray: true, description: 'UInt8 Array' }),
    __metadata("design:type", Array)
], SendBytesMessageBody.prototype, "bytes", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ type: 'string', required: false, description: 'Only for SocketIO', default: '*' }),
    __metadata("design:type", String)
], SendBytesMessageBody.prototype, "event", void 0);
exports.SendBytesMessageBody = SendBytesMessageBody;
class SendMessageReply {
}
__decorate([
    (0, swagger_1.ApiProperty)({ enum: common_1.MessageFormat }),
    __metadata("design:type", String)
], SendMessageReply.prototype, "format", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ type: 'object', description: 'Any data' }),
    __metadata("design:type", Object)
], SendMessageReply.prototype, "data", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ type: 'number', required: false, description: 'Only for binary messages' }),
    __metadata("design:type", Number)
], SendMessageReply.prototype, "size", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ type: 'string', required: false, description: 'Only for SocketIO' }),
    __metadata("design:type", String)
], SendMessageReply.prototype, "event", void 0);
exports.SendMessageReply = SendMessageReply;
class SendMessageResponse {
}
__decorate([
    (0, swagger_1.ApiProperty)({ type: 'number' }),
    __metadata("design:type", Number)
], SendMessageResponse.prototype, "messageId", void 0);
__decorate([
    (0, swagger_1.ApiProperty)({ type: SendMessageReply, required: false }),
    __metadata("design:type", SendMessageReply)
], SendMessageResponse.prototype, "reply", void 0);
exports.SendMessageResponse = SendMessageResponse;
